#include <SDL.h>

#include "Vector2.h"

#include "InputListener.h"

/*
  InputListener class
*/

InputListener::InputListener()
{
  SDL_Init(0);
}

InputListener::~InputListener()
{
}

InputEvent InputListener::poll()
{
  SDL_Event ev;
  int event = SDL_PollEvent(&ev);
  if(event)
    return InputEvent(ev);
  else
    return InputEvent();
}

/*
  InputEvent class
*/

InputEvent::InputEvent()
{
  vDefined = false;
}

InputEvent::InputEvent(SDL_Event event)
{
  mEvent = event;
  vDefined = true;
}

InputEvent::~InputEvent()
{
}

int InputEvent::type()
{
  return mEvent.type;
}

bool InputEvent::defined()
{
  return vDefined;
}

/*
  InputMouseMotionEvent class
*/

Vector2 InputMotionEvent::coor()
{
  return Vector2(mEvent.motion.x, mEvent.motion.y);
}

Vector2 InputMotionEvent::rel()
{
  return Vector2(mEvent.motion.xrel, mEvent.motion.yrel);
}

int InputMotionEvent::state()
{
  return mEvent.motion.state;
}

/*
  InputKeyEvent class
*/

int InputKeyEvent::sym()
{
  return mEvent.key.keysym.sym;
}

int InputKeyEvent::mod()
{
  return mEvent.key.keysym.mod;
}

int InputKeyEvent::state()
{
  return mEvent.key.state;
}

/*
  InputButtonEvent class
*/

int InputButtonEvent::button()
{
  return mEvent.button.button;
}

int InputButtonEvent::state()
{
  return mEvent.button.state;
}

Vector2 InputButtonEvent::motion()
{
  return Vector2(mEvent.button.x, mEvent.button.y);
}
