#ifndef _INPUTLISTENER_H
#define _INPUTLISTENER_H

#include <SDL.h>

class InputEvent;

class InputListener
{
 public:
  InputListener();
  virtual ~InputListener();

  InputEvent InputListener::poll();

  InputEvent pollEvent();
};

class InputEvent
{
public:
  InputEvent();
  InputEvent(SDL_Event event);
  virtual ~InputEvent();

  int type();
  bool defined();

  SDL_Event mEvent;
 private:
  bool vDefined;
};

class InputMotionEvent : public InputEvent
{
public:
  Vector2 coor();
  Vector2 rel();
  int state();
};

class InputKeyEvent : public InputEvent
{
 public:
  int sym();
  int mod();
  int state();
};

class InputButtonEvent : public InputEvent
{
 public:
  int button();
  int state();
  Vector2 motion();
};

#endif
